import cPickle as pickle

from nltk_lite.probability import ConditionalFreqDist
from nltk_lite.corpora import brown
from nltk_lite import tokenize

#for genre in brown.items:                       # each genre
#    for sentence in brown.tagged(genre):        # each sentence
#        for (word, tag) in sentence:            # each tagged token
#             cfdist[word].inc(tag)
fh = open("var/webxcreta_cfdist.pkl")
cfdist = pickle.load(fh)
fh.close()

FIRST_WORD = 0
PART_OF_SPEECH = 1

wordPattern = r'\w+|\$\d+\.\d+|[^\w\s]+'

def tagData(harvester):
    for entry in harvester.data:
        # tag title
        words = list(tokenize.regexp(entry['title'], wordPattern))
        title = [ (word, cfdist[word].max()) for word in words
            if cfdist[word].max() != None ]
        entry['title_tagged'] = title

        # tag content
        contentTagged = []
        words = list(tokenize.regexp(entry['content'], wordPattern))
        # find sentence boundaries
        sentencePositions = []
        tags = [ (word, cfdist[word].max())
            for word in words if cfdist[word].max() != None ]
        for index, tag in enumerate(tags):
            try:
                if (tag[0] == tag[1] == '.' and
                    'cd' not in tags[index+1][1].lower() and
                    tags[index-1][0].lower != 'no'):
                    sentencePositions.append(index)
            except IndexError:
                sentencePositions.append(index)
        lastIndex = 0
        sentences = []
        for i in sentencePositions:
            sentence = tags[lastIndex:i+1]
            # get rid of punctuation; we're not going to be that complex
            if sentence[FIRST_WORD][PART_OF_SPEECH].lower() == 'wdt':
                finalPunct = [('?', '?')]
            else:
                finalPunct = [('.', '.')]
            sentence_parts = []
            for word, partOfSpeech in sentence:
                if (partOfSpeech != '.' and
                    partOfSpeech not in """;'":()^*@#"""):
                    sentence_parts.append((word, partOfSpeech))
            sentence = sentence_parts + finalPunct
            sentences.append(sentence)
            lastIndex = i+1
        entry['contentTagged'] = sentences
    return harvester


